function instrumentlength(){
var length = document.icqform.instrumentform.value.length;
document.getElementById("instrumentformlength").innerHTML = length;
}
function Instrumentclear0(){
document.icqform.telescope.value = "";
document.icqform.eyepiece.value = "";
document.icqform.extender.value = "1.0";

document.icqform.TELEtypeform.value = "";
document.icqform.TELEdform.value = "";
document.icqform.TELEflform.value = "";
document.icqform.EPflform.value = "";
document.icqform.instrumentpowerform.value = "";
document.icqform.TELEFform.value = "";
document.icqform.EXnumform.value = "1.0";
instrumentlength();
}

function Instrumentclear(){
Instrumentclear0();
document.icqform.instrument.value = "";
document.icqform.instrumentform.value = "";
instrumentlength();
document.getElementById("flalert").innerHTML = "";

}

// 一括選択が選ばれた場合
function instrumentselect(){
var x = document.icqform.instrument.value;
document.icqform.instrumentform.value = x;
//他の項目はクリア
Instrumentclear0();
instrumentlength();
document.getElementById("flalert").innerHTML = "";
}

function powercul(fl,efl,ex){//整数値の倍率を求める関数。fl=焦点距離、efl=アイピース、ex=エクステンダー
var power = roundtoEven((Number(fl)/Number(efl))*Number(ex),0);
return power;
}


//個別入力を拾ってフォーマットする関数をあらかじめ設定
function setInstrumentformat(){

var TELEtype = document.icqform.TELEtypeform.value;//種別
var TELEd = document.icqform.TELEdform.value;//口径
var TELEfl = document.icqform.TELEflform.value;//焦点距離
var EPfl = document.icqform.EPflform.value;//アイピース焦点距離
var instrumentpower = document.icqform.instrumentpowerform.value;//倍率
var TELEF = document.icqform.TELEFform.value;//F値
var EXnum = document.icqform.EXnumform.value;//エクステンダーの倍率
if(EXnum == ""){EXnum = 1;}//フォーム入力値が空欄なら「不使用」＝1.0x

//口径のフォーマット
var TELEdformat = numberAddBlank(TELEd,3,1);

//F値のフォーマット
if(TELEF != ""){// && TELEF != NaN){//F値が入力されている場合
var TELEFcul = roundtoEven(TELEF,0);
}else if(TELEd != "" && TELEfl != ""){//F値が空欄で口径と焦点距離が入力されてるなら計算
var TELEFcul = roundtoEven(TELEfl/TELEd*0.1,0);
}else if(TELEfl == ""){//焦点距離が空欄ならF値も空欄
var TELEFcul = "  ";
}
var TELEFformat = addBlank(TELEFcul,2,"b");

//倍率のフォーマット
if(instrumentpower != "" && TELEfl == "" && EPfl == ""){
var obspower = roundtoEven(instrumentpower*EXnum,0);
}else if(instrumentpower == "" || roundtoEven(powercul(TELEfl,EPfl,EXnum),0) != instrumentpower){//倍率が空欄、もしくは異なるなら計算
if(TELEfl == "" && isNaN(TELEF) == false && isNaN(TELEd) == false){TELEfl = TELEF*TELEd*10;}//焦点距離が空欄ならあらかじめ計算
var obspower = numberAddBlank(powercul(TELEfl,EPfl,EXnum));
document.icqform.instrumentpowerform.value = obspower;
}else{
var obspower = instrumentpower;
}

var powerformat = numberAddBlank(obspower,4,0);
var instrumentformat = TELEdformat + TELEtype + TELEFformat + powerformat;//フォーマットに出力する文字列

document.icqform.instrumentform.value = instrumentformat;
//return instrumentformat;
////instrumentlength();//文字数カウント

//焦点距離とF値が異なる場合は警告。
if(roundtoEven(TELEF,0) == roundtoEven(TELEfl/TELEd*0.1,0) || TELEfl == "" || TELEF == "" || TELEd == ""){
document.getElementById("flalert").innerHTML = "";

}else{
document.getElementById("flalert").innerHTML = "<b>口径と焦点距離から算出したF値（F" + roundtoEven(TELEfl/TELEd*0.1,0) + "）が、入力値と食い違っています。入力値を確認してください。</b>";
}
return instrumentformat;
}

//望遠鏡が選択された時にフォームに自動入力
function TELEselect(){
var TELEd = SelectTELE[document.icqform.elements["telescope"].selectedIndex][0].slice(0,5);//口径
document.icqform.elements["TELEdform"].value = TELEd;
document.icqform.elements["TELEtypeform"].value = SelectTELE[document.icqform.elements["telescope"].selectedIndex][0].slice(5,6);//種別
var TELEfl = Number(SelectTELE[document.icqform.elements["telescope"].selectedIndex][0].slice(6));//焦点距離
document.icqform.elements["TELEflform"].value = TELEfl;
//F値。初期値は空欄のはず。計算して入力。
var TELEF = document.icqform.TELEFform.value;
if(document.icqform.TELEFform.value == "" || TELEF != roundtoEven(0.1*TELEfl/TELEd,0)){
document.icqform.TELEFform.value = roundtoEven(0.1*TELEfl/TELEd,0);
}
//以下は倍率計算してフォームに入れる設定
if(document.icqform.EPflform.value != ""){//アイピースに既に入力がある場合
if(document.icqform.EXnumform.value == ""){var EXnum = Number(1);}//エクステンダー未入力時は1.0
var power = powercul(document.icqform.TELEflform.value,document.icqform.EPflform.value,document.icqform.EXnumform.value);
document.icqform.elements["instrumentpowerform"].value = power;
//ついでにフォームに入力
setInstrumentformat();
}

//観測機器一括選択はクリアする
document.icqform.instrument.value = "";
}


//アイピースが選択された時にフォームに自動入力
function EPselect(){
var EPfl = SelectEP[document.icqform.elements["eyepiece"].selectedIndex][0];
document.icqform.EPflform.value = EPfl;

//以下は倍率計算してフォームに入れる設定
if(document.icqform.TELEflform.value != ""){//焦点距離に入力がある場合
if(document.icqform.EXnumform.value == ""){var EXnum = Number(1);}//エクステンダー未入力時は1.0
var power = powercul(document.icqform.TELEflform.value,document.icqform.EPflform.value,document.icqform.EXnumform.value);
document.icqform.elements["instrumentpowerform"].value = power;
//ついでにフォームに入力
setInstrumentformat();
}
//観測機器一括選択はクリアする
document.icqform.instrument.value = "";
}

//エクステンダーが選択された時にフォームに自動入力
function EXselect(){
document.icqform.elements["EXnumform"].value = SelectEX[document.icqform.elements["extender"].selectedIndex][0];

//以下は倍率計算してフォームに入れる設定
if(document.icqform.TELEflform.value != ""){//焦点距離に入力がある場合
var power = powercul(document.icqform.TELEflform.value,document.icqform.EPflform.value,document.icqform.EXnumform.value);
document.icqform.elements["instrumentpowerform"].value = power;
//ついでにフォームに入力
setInstrumentformat();
}
//観測機器一括選択はクリアする
document.icqform.instrument.value = "";
}
