//引数numは1970年からの経過ミリ秒数

//定義関数changeC()を使用。

//地球位置（黄道座標系）
//引数numは1970年からの経過ミリ秒数
function earthposition(num){//入力されるべき時刻は地球時（TT=UTC+ΔT=約70秒）

var TTnow = new Date(num);

//var TTnow = new Date();
//TTnow.setTime(num);
//var TT2000 = new Date(2000,0,1,12,0,0,0,0);//2000.0の1970年からの経過ミリ秒数
var TT2000 = 946695600000;
var TTunixmillitime = TTnow - TT2000;//2000.0からの日数

//var TT = (TTnow - TT2000)/86400000;//2000.0からの日数
var TT = (Number(TTunixmillitime))/86400000;//2000.0からの日数

var Em0 = (357.5286 + 0.9856003 * TT)%360;

var Mem= (174.7948 + 4.0923344 * TT) * Math.PI/180;
//var Em = (357.5286 + 0.9856003 * TT) * Math.PI/180;
var Em = Em0 * Math.PI/180;

var Vm = ( 49.943 + 1.60212 * TT) * Math.PI/180;
var Mm = ( 19.6 + 0.52402 * TT) * Math.PI/180;
var Jm = ( 19.9 + 0.08308 * TT) * Math.PI/180;
var Sm = (317.0202 + 0.03344414 * TT) * Math.PI/180;
var MD = (297.9 + 12.19075 * TT) * Math.PI/180;
var MF = ( 93.3 + 13.22935 * TT) * Math.PI/180;
var MN = (125.0 -  0.05295 * TT) * Math.PI/180;
var ML = (333.8 + 13.06499 * TT) * Math.PI/180;
var ZZ = 1 - 0.00000006845 * TT;

var L0 = (180*3600 + 1009677.501 + 3548.330404 * TT + 0.000000000846 * TT * TT) % (360*60*60);
//永年摂動項
var LDL = 6.40 * Math.sin(0.000553 * TT * Math.PI/180 + 251.4 * Math.PI/180);
LDL = LDL + (1.87-0.0000004*TT) * Math.sin(0.004114*TT*Math.PI/180+207.5*Math.PI/180);
LDL = LDL + 0.27 * Math.sin(3.258*TT*Math.PI/180+151*Math.PI/180);
LDL = LDL + 0.20 * Math.sin(2.446*TT*Math.PI/180+129*Math.PI/180);


var LD = 6892.50 * ZZ * Math.sin(Em);
LD = LD +71.97 * (2*ZZ-1) * Math.sin(2*Em);
LD = LD + 7.21 * Math.cos(Jm - Em - 179.5*Math.PI/180);
LD = LD + 6.47 * Math.sin(MD);
LD = LD + 5.53 * Math.cos(-2*Vm+2*Em-148.3*Math.PI/180);
LD = LD + 4.83 * Math.cos(-  Vm+  Em-299.1*Math.PI/180);
LD = LD + 2.73 * Math.cos( 2*Jm-2*Em-87.1*Math.PI/180);
LD = LD + 2.60 * Math.cos(   Jm -263.2*Math.PI/180);
LD = LD + 2.50 * Math.cos(-2*Vm+3*Em-315.9*Math.PI/180);
LD = LD + 2.04 * Math.cos( 2*Mm-2*Em-343.9*Math.PI/180);
LD = LD + 1.77 * Math.cos( 2*Mm-  Em-200.4*Math.PI/180);
LD = LD + 1.61 * Math.cos( 2*Jm-  Em-109.5*Math.PI/180);
LD = LD + 1.56 * Math.cos(-3*Vm+4*Em-345.3*Math.PI/180);
LD = LD + 1.04 * Math.sin( 3*Em);
LD = LD + 1.02 * Math.cos(-3*Vm+5*Em-318.2*Math.PI/180);
LD = LD + 0.67 * Math.cos(-3*Vm+3*Em-177.7*Math.PI/180);
LD = LD + 0.58 * Math.cos( 4*Mm-2*Em-334*Math.PI/180);
LD = LD + 0.56 * Math.cos( 3*Jm-2*Em-83*Math.PI/180);
LD = LD + 0.50 * Math.cos( 4*Mm-3*Em-105*Math.PI/180);
LD = LD + 0.42 * Math.cos( 3*Mm-2*Em-339*Math.PI/180);
LD = LD + 0.42 * Math.cos(   Sm-  Em-101*Math.PI/180);
LD = LD - 0.43 * Math.sin(MD-ML);
LD = LD + 0.32 * Math.cos( Sm-269*Math.PI/180);
LD = LD + 0.28 * Math.cos( Mm-Em-218*Math.PI/180);
LD = LD + 0.21 * Math.cos(-4*Vm+4*Em-206*Math.PI/180);
LD = LD + 0.21 * Math.cos(3*Jm-Em-99*Math.PI/180);
LD = LD + 0.20 * Math.cos(5*Mm-3*Em-101*Math.PI/180);
LD = LD + 0.18 * Math.sin(MD+ML);
LD = LD + 0.17 * Math.sin(MD-Em);
LD = LD + 0.16 * Math.cos(3*Jm-3*Em-171*Math.PI/180);
LD = LD + 0.16 * Math.cos(Jm-2*Em-199*Math.PI/180);
LD = LD + 0.15 * Math.cos(6*Mm-4*Em-227*Math.PI/180);
LD = LD + 0.15 * Math.cos(-5*Vm+8*Em-360*Math.PI/180);
LD = LD + 0.15 * Math.cos(-4*Vm+6*Em-344*Math.PI/180);
LD = LD + 0.14 * Math.cos(-4*Vm+5*Em-195*Math.PI/180);
LD = LD + 0.13 * Math.cos(3*Mm-3*Em-294*Math.PI/180);
LD = LD + 0.12 * Math.cos(-5*Vm+7*Em-195*Math.PI/180);
LD = LD + 0.12 * Math.cos(-2*Vm+Em-149*Math.PI/180);
LD = LD + 0.11 * Math.cos(2*Sm-Em-294*Math.PI/180);
LD = LD + 0.11 * Math.cos(2*Sm-2*Em-291*Math.PI/180);
LD = LD + 0.11 * Math.cos(7*Mm-4*Em-223*Math.PI/180);
LD = LD + 0.10 * Math.cos(6*Mm-3*Em-96*Math.PI/180);
LD = LD + 0.09 * Math.cos(5*Mm-4*Em-55*Math.PI/180);
LD = LD + 0.08 * Math.cos(-5*Vm+5*Em-236*Math.PI/180);
LD = LD + 0.08 * Math.cos(4*Jm-2*Em-78*Math.PI/180);
LD = LD + 0.08 * Math.cos(-Mem-297*Math.PI/180);
LD = LD + 0.07 * Math.cos(-Vm+2*Em-208*Math.PI/180);
LD = LD + 0.07 * Math.cos(Jm+Em-276*Math.PI/180);
LD = LD + 0.07 * Math.cos(2*Jm-253*Math.PI/180);
LD = LD + 0.07 * Math.cos(2*Jm-3*Em-81*Math.PI/180);
LD = LD + 0.06 * Math.cos(9*Mm-5*Em-346*Math.PI/180);
LD = LD - 0.06 * Math.sin(MD+Em);
LD = LD + 0.05 * Math.cos(8*Mm-5*Em-349*Math.PI/180);

var LDn = (L0 + LDL + LD)/3600;// - 0.0057;//視位置。光行差補正済み。

var tt = TT/36525;
var L00 = (5029.0966)*tt + (1.11113 - 0.03302)*tt*tt;//視位置からJ2000.0への補正量
LD = (L0 + LDL + LD - L00)/3600;//2000.0分点の位置
if(LD < 0){LD = LD + 360;}
else if(LD > 360){LD = LD - 360;}
//黄緯
var B00 = (47.0029 * tt) * Math.sin(LD * Math.PI/180);//歳差補正

var B0 = 0.577 * Math.sin(MF);
B0 = B0 - 0.210 * Math.cos(-3*Vm+4*Em-152*Math.PI/180);
B0 = B0 - 0.166 * Math.cos( 2*Jm-Em-266*Math.PI/180);
B0 = B0 - 0.092 * Math.cos(-  Vm+2*Em-94*Math.PI/180);
B0 = B0 - 0.067 * Math.cos(-2*Vm+3*Em-123*Math.PI/180);
B0 = B0 - 0.047 * Math.sin(MF-ML);
B0 = B0 - 0.031 * Math.cos(-4*Vm+5*Em-2*Math.PI/180);
B0 = B0 - 0.029 * Math.cos(-Mem-145*Math.PI/180);
B0 = B0 - 0.023 * Math.cos(-2*Vm+Em-173*Math.PI/180);
B0 = B0 - 0.023 * Math.cos(   Jm+Em-268*Math.PI/180);
B0 = B0 + 0.021 * Math.sin( 2*MD-MF);

var BBn =  - B0/3600;//視位置
var BB = - (B0 - B00)/3600;//2000.0年分点の位置

//距離
var  R0 = 3044;
R0 = R0 - 725564 * ZZ * Math.cos(Em);
R0 = R0 - 9092 * (2*ZZ - 1) * Math.cos(2*Em);

R0 = R0 + 1338 * Math.cos(MD);
R0 = R0 +  707 * Math.cos(Jm-Em-89.5*Math.PI/180);
R0 = R0 +  683 * Math.cos(-2*Vm+2*Em-58.3*Math.PI/180);
R0 = R0 +  403 * Math.cos(2*Jm-2*Em-357.1*Math.PI/180);
R0 = R0 +  236 * Math.cos(-Vm+Em-209.1*Math.PI/180);
R0 = R0 +  205 * Math.cos(2*Mm-2*Em-253.8*Math.PI/180);
R0 = R0 +  150 * Math.cos(-3*Vm+4*Em-255.3*Math.PI/180);
R0 = R0 +  146 * Math.cos(2*Jm-Em-19.5*Math.PI/180);
R0 = R0 +  146 * Math.cos(3*Em);
R0 = R0 -  133 * Math.cos(MD-ML);
R0 = R0 +  104 * Math.cos(-3*Vm+3*Em-87.6*Math.PI/180);
R0 = R0 +   87 * Math.cos(-2*Vm+3*Em-227*Math.PI/180);
R0 = R0 +   80 * Math.cos(3*Jm-2*Em-353*Math.PI/180);
R0 = R0 +   48 * Math.cos(4*Mm-3*Em-15*Math.PI/180);
R0 = R0 +   43 * Math.cos(Sm-Em-11*Math.PI/180);
R0 = R0 +   38 * Math.cos(-4*Vm+4*Em-116*Math.PI/180);
R0 = R0 +   37 * Math.cos(MD+Em);
R0 = R0 +   36 * Math.cos(MD-Em);
R0 = R0 +   28 * Math.cos(3*Jm-3*Em-81*Math.PI/180);
R0 = R0 +   24 * Math.cos(Jm-339*Math.PI/180);
R0 = R0 +   22 * Math.cos(3*Mm-2*Em-339*Math.PI/180);
R0 = R0 +   21 * Math.cos(Jm-2*Em-112*Math.PI/180);
R0 = R0 +   20 * Math.cos(-4*Vm+5*Em-105*Math.PI/180);
R0 = R0 +   19 * Math.cos(-3*Vm+5*Em-50*Math.PI/180);
R0 = R0 +   17 * Math.cos(3*Jm-Em-9*Math.PI/180);
R0 = R0 +   17 * Math.cos(3*Mm-3*Em-204*Math.PI/180);
R0 = R0 +   16 * Math.cos(-5*Vm+5*Em-145*Math.PI/180);
R0 = R0 +   16 * Math.cos(2*Sm-2*Em-201*Math.PI/180);
R0 = R0 +   16 * Math.cos(-2*Vm+Em-58*Math.PI/180);
R0 = R0 +   15 * Math.cos(2*Mm-Em-295*Math.PI/180);
R0 = R0 +   15 * Math.cos(Mm-Em-128*Math.PI/180);
R0 = R0 -   14 * Math.cos(3*Em);
R0 = R0 +   14 * Math.cos(-5*Vm+7*Em-105*Math.PI/180);
R0 = R0 -   14 * Math.cos(MD+Em);
R0 = R0 +   14 * Math.cos(6*Mm-4*Em-137*Math.PI/180);
R0 = R0 +   11 * Math.cos(4*Jm-2*Em-348*Math.PI/180);
R0 = R0 +   11 * Math.cos(2*Sm-Em-204*Math.PI/180);
R0 = R0 +   10 * Math.cos(2*Jm-3*Em-351*Math.PI/180);
R0 = R0 +   11 * Math.cos(5*Mm-4*Em-325*Math.PI/180);

R0 = R0/100000000;
var RR = Math.pow(10,R0);

//結果の格納
var Earth = new Array();
Earth[0] = TT;//J2000.0からの日数
Earth[100] =Number(TTnow);//J2000.0からの日数
Earth[101] =Number(TT2000);//J2000.0からの日数
Earth[102] = TTunixmillitime;
Earth[110] = L0;

Earth[1] = LD;//2000.0の黄経
Earth[2] = BB;//2000.0の黄緯
Earth[3] = RR;//距離
if(LDn < 0){LDn = LDn + 360;}
else if(LDn > 360){LDn = LDn - 360;}
Earth[4] = LDn;//視黄経
Earth[5] = BBn;//視黄緯

var x = new Array();
x = changeC("p",RR,(90-BB)*Math.PI/180,LD*Math.PI/180);//2000.0の黄経・黄緯から直交座標を求める

Earth[6] = x[0];//2000.0の黄道座標系X
Earth[7] = x[1];//2000.0の黄道座標系Y
Earth[8] = x[2];//2000.0の黄道座標系Z

var xn = new Array();
xn = changeC("p",RR,(90-BBn)*Math.PI/180,LDn*Math.PI/180);//視黄経・黄緯から直交座標を求める

Earth[9] = xn[0];//視黄経直交座標X
Earth[10] = xn[1];
Earth[11] = xn[2];

var ε2000 = new Array();
ε2000 = preC(TT2000);//黄道傾斜角ε(2000.0)
var εn = new Array();
εn = preC(TTnow);//黄道傾斜角ε(視位置）


var a = new Array();
a = changeR(1,Earth[6],Earth[7],Earth[8],ε2000[3])//2000.0の黄道直交から2000.0の赤道直交を求める

Earth[12] = a[0];//2000.0の赤道座標系X
Earth[13] = a[1];
Earth[14] = a[2];
Earth[115]= ε2000[3]*180/Math.PI;

var an = new Array();
an = changeR(1,xn[0],xn[1],xn[2],εn[3])//視黄道直交を赤道直交に。
Earth[15] = an[0];//視赤道座標系X
Earth[16] = an[1];//視赤道座標系Y
Earth[17] = an[2];//視赤道座標系Z

Earth[18] = εn[3];
Earth[19] = Math.atan2(an[1],an[0])*180/Math.PI;//視赤径単位°
Earth[20] = Math.asin(an[2]/RR)*180/Math.PI;//視赤緯単位°

Earth[31] = Math.atan2(a[1],a[0])*180/Math.PI;//2000.0赤径単位°
Earth[32] = Math.asin(a[2]/RR)*180/Math.PI;//2000.0赤緯単位°
return Earth;//結果は配列で複数出力
}

