function ICQformatRead(fomat){
//彗星名取得
var cometname = fomat.slice(0,11);

//観測日時取得
var datetimeY = fomat.slice(11,15);
var datetimeM = fomat.slice(16,18);
var datetimeD = fomat.slice(19,25);
var datetimeDD = Math.floor(datetimeD);//日の整数
var datetimeHH = Math.floor((datetimeD - datetimeDD)*24);//時の整数
var datetimeMM = ((datetimeD - datetimeDD)*24 - datetimeHH)*60;//分の整数
var tz = (new Date()).getTimezoneOffset();//タイムゾーン。セットされた時刻がPCのローカルと認識されてしまうため（不要？）
var datetime = new Date(datetimeY,datetimeM-1,datetimeDD,datetimeHH,datetimeMM-tz);
var datetimeUNIXtime = datetime.getTime();//観測日時のUNIXTime

var col26 = fomat.slice(25,26);
var col75 = fomat.slice(74,75);
var nobsl = "";
var software = "";
var magair = "";
if(col26 == "l"){nobsl = "l";}//上限光度は恒星の極限等級（恒星をぼかさず測定）
else if(col26 == "x" || col75 == "x"){software = "x";}//ソフトウェアを使用
else if(col26 == " "){magair ="";}//減光補正空欄
else{magair = col26;}//減光補正に入力値

var col27 = fomat.slice(26,27);
var magmethod = col27;//光度測定方法

var menus = "";
//非観測
var col28 = fomat.slice(27,28);
if(col28 == "["){
var magnobs = "[";}
else if(col28 == "-"){
menus = "-";}
else{
var magnobs = "";
menus = "";
}

//光度
var mag = "";
var col29 = fomat.slice(28,32);
if(isNaN(col29) == true){mag = "";}//光度無し
else{
mag = menus + col29;
}

//およそ
var amag = "";
var col33 = fomat.slice(32,33);
if(col33 == ":"){amag = ":";}

//比較星カタログ
var cat = fomat.slice(33,35);

var TELEd = fomat.slice(35,40);//望遠鏡口径
var TELEtype = fomat.slice(40,41);//望遠鏡種別
var TELEF = Number(fomat.slice(41,43));//望遠鏡F値
var TELEmgf = Number(fomat.slice(43,47));//望遠鏡倍率

//コマ注釈
var COMA0 = "";
var COMAnote = "";
var col49 = fomat.slice(48,49);//コマ注釈
if(isNaN(col49) == true){COMAnote = col49;}
else{COMA0 = col49;}//数字の場合

//コマ視直径
var col50 = fomat.slice(49,54);
var COMA = COMA0 + col50;

//集光度注釈
var DCnote = fomat.slice(54,55);
//集光度
var DC = fomat.slice(55,57);

//尾の注釈
var col58 = fomat.slice(57,58);
var col59 = fomat.slice(58,59);

var TAILnote = "";
var TAIL0 = "";
if(isNaN(col59) == true){TAILnote = col59;}
else{TAIL0 = col59;}

//尾の長さ
var TAIL = col58 + TAIL0 + fomat.slice(59,63);

//尾の単位
var TAILunit = fomat.slice(63,64);

//尾の位置角
var TAILang = fomat.slice(64,67);

//報告
var ICQxx = fomat.slice(68,74);

//観測者
var OBSxx = fomat.slice(75,80);

var data = new Array();
data[0] = cometname;
data[1] = datetimeY;
data[2] = datetimeM;
data[3] = datetimeD;
data[4] = datetime;
data[5] = datetimeUNIXtime;

data[6] = magnobs;
data[7] = nobsl;
data[8] = magair;
data[9] = magmethod;
data[10] = mag;
data[11] = amag;
data[12] = cat;
data[13] = software;
data[14] = "";
data[15] = TELEd;
data[16] = TELEtype;
data[17] = TELEF;
data[18] = TELEmgf;
data[19] = COMAnote;
data[20] = COMA;
data[21] = DCnote;
data[22] = DC;
data[23] = TAILnote;
data[24] = TAIL;
data[25] = TAILang;
data[26] = TAILunit;

data[27] = ICQxx;
data[28] = OBSxx
/*
data[] = 
data[] = 
data[] = 
data[] = 

*/
return data;
}