//クリックされた時の動作
function cul(){

//ΔUT1出典　http://maia.usno.navy.mil/ser7/finals2000A.all
//観測日時
var lYY,lMM,lDD,lHH,lmm,lSS;//入力したローカルの年月日・日時を定義
lYY = document.icqform.year.value;
//lYY = document.getElementById("year").value;
lMM = document.icqform.month.value;
lDD = document.icqform.day.value;
lHH = document.icqform.hour.value;
lmm = document.icqform.min.value;
lSS = document.icqform.sec.value;
var DTinput = document.icqform.dtinput.value;
var TIMEzone = document.icqform.timezone.value ;//タイムゾーンを取得

//観測点の情報取得
var λ = Number(document.icqform.obsλ.value);
var φ = Number(document.icqform.obsφ.value);
var height = Number(document.icqform.obsheight.value);

var TTnowUTC = new Date(lYY,lMM - 1,lDD,lHH - TIMEzone,lmm,lSS,0);//観測日時
var TTnowmillisec = TTnowUTC.getTime();//観測日のミリ秒（1970年からの経過ミリ秒数）

if(DTinput != ""){
var TTnowDT = DTinput;
}else{
var TTnowDT = deltaT(TTnowmillisec);//観測日時のΔT
}
var TTnowTT = new Date;
var TTms = TTnowmillisec + TTnowDT * 1000;//観測日時の地球時ミリ秒単位
TTnowTT.setTime(TTms);//地球時

var Earth = new Array();//結果を出力するための配列を定義
Earth = earthposition(TTms);//地球位置
var TT = Earth[0];
var LD = Earth[1];
var BB = Earth[2];
var RR = Earth[3];//地球の日心距離

var λSun = Earth[4] + 180;//太陽の視黄経
if(λSun > 360){λSun = λSun - 360;}
var Exx = Earth[12];//地球の赤道直交座標2000.0
var Eyy = Earth[13];
var Ezz = Earth[14];
var Exxn = Earth[15];//地球の赤道直交座標瞬時
var Eyyn = Earth[16];
var Ezzn = Earth[17];
 

var TTDay = TTms/86400000;//1970年からの経過ミリ秒数を日単位に。

var orbitfomatform0 = document.icqform.orbitfomatform.value;//HTMLのフォームから
if(orbitfomatform0 == ""){
var orbitfin0 = document.icqform.cometselect.value;//user.jsから
var orbitftype = orbitfin0.slice(11,12);
var orbitfin = orbitfin0.slice(12);
}else{
var orbitftype = document.icqform.formattype.value;
var orbitfin = orbitfomatform0;
}

var oedata = new Array();
oedata = readOrbitFormat(orbitfin,orbitftype);

var T = oedata[1];
T = TtoUNIXTime(T,4);//UnixTimeを日の小数にする
var q = oedata[2];
var e = oedata[3];
var ω = oedata[4];
var Ω = oedata[5];
var i = oedata[6];
var E = oedata[7];
var H = oedata[8];
var k = oedata[9];
var name = oedata[10];
var note = oedata[11];


var cometP = new Array();
cometP = orbit("d",TTms,T,q,e,ω,Ω,i,E,k,H,name,note);
var rr = cometP[0];//彗星の日心距離
var Δ = cometP[20];//地心距離
var sc = cometP[21];//太陽離角
var β = cometP[22];//位相角

var α = cometP[31];//2000.0の彗星の赤経。単位°
var δ = cometP[32];
var VSun = cometP[33];//太陽方向角
var VSunA = cometP[34];//尾の方向角

var αn = cometP[41];//彗星の視赤経
var δn = cometP[42];

var cometDist = "r=" + rr.toFixed(3) + "au　Δ=" + Δ.toFixed(3) + "au<br />";

//彗星位置2000.0
var α2000HM = unitConv(α/15,1,"DM","<sup>h</sup>","<sup>m</sup>","");
var δ2000DM = unitConv(δ,0,"+DM","<sup>°</sup>","<sup>’</sup>","");

var cometP2000 = "α=" + α2000HM + "　" + "δ=" + δ2000DM + "（2000.0）<br />";

//彗星位置視位置（平均）
var αnHM = unitConv(αn/15,1,"DM","<sup>h</sup>","<sup>m</sup>","");
var δnDM = unitConv(δn,0,"+DM","<sup>°</sup>","<sup>’</sup>","");

var cometPn = "α=" + αnHM + "　" + "δ=" + δnDM + "（視位置）<br />";

//光度

var cometm1 = eval(H) + eval(2.5 * k * Math.log(rr)/Math.log(10)) + eval(5 * Math.log(Δ)/Math.log(10));
var commentmag = "MPC予報光度 m<sub>1</sub>=" + cometm1.toFixed(1) + "等<br />";

//高度
var cometHoriz = new Array();
var cometAltAtmosCom;
cometHoriz = horizontal(αn/15,δn,TTnowmillisec,λ,φ);
var cometAlt = cometHoriz[1];//彗星高度
if(cometAlt < 10 && cometAlt > -1){
cometAltAtmos = cometAlt + 0.0167/Math.tan((cometAlt + 7.31/(cometAlt + 4.4))*Math.PI/180);//大気差補正（※「見かけ高度」として代入すべき変数に真高度を代入。概算）
cometAltAtmosCom = "<small>（大気差を補正した見かけ高度＝約" + cometAltAtmos.toFixed(1) + "°）</small>";
}else{
cometAltAtmosCom = "";
}
var cometAzm = cometHoriz[2];//彗星方位角（北から東回り）
var cometdirect = directname(cometHoriz[2],"ja");
var cometHorizCom = "高度 alt=" + cometAlt.toFixed(1) + "°" + cometAltAtmosCom + "/方位角 A=" + cometAzm.toFixed(1) + "°（" + cometdirect + "）<br />";


//J2000.0の太陽位置
var αSun2000 = Earth[31]/15+12;//赤経。時単位
var δSun2000 = -Earth[32];//赤緯。度単位

//太陽位置と高度の計算（この辺未整理）
var αSun = Earth[19]/15+12;//視赤経時
var αSunrad = αSun*Math.PI/180;//月計算で使用
var δSun = -Earth[20];//視赤緯度
var δSunrad = δSun*Math.PI/180;//月計算で使用
var altSun = new Array();
var Δdr = new Array();
var Δds = new Array();
altSun = horizontal(αSun,δSun,TTnowmillisec,λ,φ);//太陽高度
//var altSun = horizontal(αSun,δSun,TTms,λ,φ);//太陽高度
/*
var HASun = altSun[5];//太陽時角


var Sun0 = new Array();
var altSun0 = new Array();
var αSun0 = new Array();
var δSun0 = new Array();
var HSun0  = new Array();
var HA0 = new Array();
var risetime0 = new Array();
var settime0 = new Array();

var altset = -18;//求める高度（-18で薄明）
//var altset = -0.266994/RR - 2.12*Math.sqrt(height)/60 - 0.58556 + 8.794/(RR*3600);

var rs = -1;//-1で出。1で没
var HA1 = riset(δSun,φ,altset);//太陽時角1次//薄明-18°
Δdr[0] = (-HASun - HA1)/360*86400000;//薄明開始（出）時刻補正値単位ミリ秒
Δds[0] = (-HASun + HA1)/360*86400000;//薄明終了（没）時刻

risetime0[0] = TTms + Δdr[0];//近似的な出時刻
settime0[0] = TTms + Δds[0];//近似的な出時刻

//出
for(var i=0;Math.abs(Δdr[i]) > 1;i++){
if(i == 100) break;//100回やってダメなら諦める
Sun0 = earthposition(risetime0[i]);//視赤緯を求める
altSun0 = horizontal(Sun0[19]/15+12,-Sun0[20],risetime0[i] - TTnowDT * 1000,λ,φ);//太陽時角を求める
//altSun0[5];//近似的な時角
HA0 = riset(-Sun0[20],φ,altset);//太陽時角i次
Δdr[i+1] = (-altSun0[5] - HA0)/360*86400000;//出時刻補正値単位ミリ秒
risetime0[i+1] = risetime0[i] + Δdr[i+1];
var risetime = risetime0[i+1];
}

var risetimedate = new Date(risetime + TIMEzone*3600000 - TTnowDT * 1000 + 30000);//ローカル標準時（ΔT補正済み）四捨五入のため30秒加算
var rised = risetimedate.getDate();
var riseh = risetimedate.getHours();
var risem = risetimedate.getMinutes();
var rises = risetimedate.getSeconds();
//分が1桁の時先頭に0を追加
if(Math.floor(risem) < 10 ){risem = "0" + risem;}
var risecom = rised + "日" + riseh+ "時" + risem + "分";

//没
for(var i=0;Math.abs(Δds[i]) > 1;i++){
if(i == 100) break;//100回やってダメなら諦める
Sun0 = earthposition(settime0[i]);
altSun0 = horizontal(Sun0[19]/15+12,-Sun0[20],settime0[i] - TTnowDT * 1000,λ,φ);//太陽高度

//altSun0[5];//近似的な時角
HA0 = riset(-Sun0[20],φ,altset);//太陽時角i次
Δds[i+1] = (-altSun0[5] + HA0)/360*86400000;//出時刻補正値単位ミリ秒
settime0[i+1] = settime0[i] + Δds[i+1];
var settime = settime0[i+1];
}

var settimedate = new Date(settime + TIMEzone*3600000 - TTnowDT * 1000 + 30000);
var setd = settimedate.getDate();
var seth = settimedate.getHours();
var setm = settimedate.getMinutes();
var sets = settimedate.getSeconds();
//分が1桁の時先頭に0を追加
if(Math.floor(setm) < 10 ){setm = "0" + setm;}
var setcom = setd + "日" + seth+ "時" + setm + "分";
//
if(HASun < 0 && HASun > -180){
var twlcom = "天文薄明始=" + risecom;
}else{
var twlcom = "天文薄明終=" + setcom;
}
*/
var suncomment = "太陽高度 alt<sub>&#x25C9;</sub>=" + altSun[1].toFixed(1) + "°<br />";

//観測日と元期との差を調べる
//Eをスライスして1970年からのミリ秒数に修正。TTnowmillisec＝観測日（1970年からの秒数）との差を求める。
if(E == "        "){
var ΔE = "※初期軌道等のため元期が定義（指定）されていません。";
}else{
var EYY = E.slice(0,4);
var EMM = E.slice(4,6);
var EDD = E.slice(6,8);
var Edate = new Date(EYY,EMM-1,EDD);
var Edatemilli = Edate.getTime();//元期のミリ秒（1970年からの経過ミリ秒数）

var ΔE = (TTnowmillisec - Edatemilli)/86400000;
var ΔE = "軌道の元期：" + E + " <small>（観測日は元期から" + ΔE.toFixed(1) + "日経過）</small>";
}


//観測値から実数値を求める。
//コマ視直径から実寸を求める。
var COMA0 = document.icqform.coma.value;
var COMAtlue = Δ*Math.tan(COMA0 / 60 * Math.PI/180) * 149597870;//キロメートル単位のコマ直径

//説明文出力用
if(COMA0 != ""){
var COMAE = COMA0 + "'のコマ実直径 = " + (COMAtlue/10000).toFixed(1) + "万km" + "<small>（月軌道円の"+ (COMAtlue / 769000).toFixed(1)+ "倍）</small><br />";
}else{
var COMAE = "";
}

var dsec = Δ*Math.tan(1 / 3600 * Math.PI/180) * 149597870;//彗星の位置における1秒角の大きさ。
//

//尾の実長
var TAIL0 = document.icqform.tail.value;
var TAILunit = document.icqform.tailunit.value;
if(TAILunit == "d"){//「度」の時
var TAILr = TAIL0 * Math.PI/180;//ラジアン単位の尾の長さ
var TAILunitname = "°";//単位名
}else if(TAILunit == "m"){
var TAILr = TAIL0/60 * Math.PI/180;
var TAILunitname = "'";
}else if(TAILunit == "s"){
var TAILr = TAIL0/3600 * Math.PI/180;
var TAILunitname = "\"";
}

var TAILtlue = Δ*(Math.sin(TAILr))/(Math.sin(β*Math.PI/180 - TAILr));//尾の実長

//説明文出力用
if(TAIL0 != ""){
var TAILtlueE = TAIL0 + TAILunitname + "の尾の実長 = " + TAILtlue.toFixed(5) + "au <small>(" + (TAILtlue*14959.7870).toFixed(0) + "万km)</small><br />";
}else{
var TAILtlueE = "";
}

//時刻の再出力。
//時の入力がない場合に、強制的に0時とする。
if(lHH == ""){
lHH = 0;
}
//分・秒の入力がない場合に、出力しない
var lmmE;
if(lmm == ""){
lmmE = "";
}else{
lmmE = lmm + "分";
}
var lSSE;
if(lSS == ""){
lSSE = "";
}else{
lSSE = lSS + "秒";
}

var lOBSTime = lYY + "年" + lMM + "月" + lDD + "日" + lHH + "時" + lmmE + lSSE ;
//小数点5桁の日付
var uddr5 = getlocaltoUT(lYY,lMM,lDD,lHH,lmm,lSS,0,TIMEzone,5,"date");//日の小数のみを出力

//document.getElementById("uddr5").innerHTML = uddr5 + "UT";

//TTを表示
var UTsec = getlocaltoUT(lYY,lMM,lDD,lHH,lmm,lSS,0,TIMEzone,0,"sec");

//var delt = deltaT(UTsec);
var TTdate = getlocaltoUT(lYY,lMM,lDD,lHH,lmm,lSS + TTnowDT,0,TIMEzone,5,"date");
//document.getElementById("deltat").innerHTML = "=" + TTdate+ "TT (ΔT=" + delt + "s)";



var MAG00 = document.icqform.mag.value;//観測光度m1読み込み
var MAGA;//絶対等級
if(MAG00 == ""){
MAGA = "";
}else{
MAGA = "絶対等級M<sub>1</sub> = " + (MAG00 - 5*Math.log(Δ) / Math.log(10)).toFixed(1) + "等<small>（1auからの光度）</small><br />";
}
/*
//標準等級推定。
if(MAG00 != ""){
var k01 = document.icqform.k01.value;//係数k1を読み込み
var k02 = document.icqform.k02.value;//係数k2を読み込み

if(k != ""){
var H0c = MAG00 - 5*Math.log(Δ) / Math.log(10) - k*2.5*Math.log(rr) / Math.log(10);
var H00c = "H<sub>" + k*2.5 + "(MPC採用値)</sub> = " + H0c.toFixed(2);//MPCからの読み込み
}else{
var H00c = "";
}

var H01 = MAG00 - 5*Math.log(Δ) / Math.log(10) - k01*Math.log(rr) / Math.log(10);
var H01c = "H<sub>" + k01 + "</sub> = " + H01.toFixed(2);

if(k02 != ""){
var H02 = MAG00 - 5*Math.log(Δ) / Math.log(10) - k02*Math.log(rr) / Math.log(10);
var H02c = "H<sub>" + k02 + "</sub> = " + H02.toFixed(2);
}else{
var H02c = "";
}
var Hmag = "";//"m<sub>1</sub>=" + MAG00 + "とした時の標準等級：" + H00c + "　" + H01c + "　" + H02c + "<br />";
}else{
Hmag = "";
}
*/
//観測時刻の日の小数表記
var TimedataE = lOBSTime + "<small>（TZ=" + TIMEzone + "）</small>の小数表記：<b>" + uddr5 + "UT</b> = " + TTdate+ "TT (ΔT=" + TTnowDT + "s)<br />";

/*
//月
var Mooncomment = "";
var Mooncomment0 = "";
var Mooncomment1 = "";

var Moon = new Array();
Moon = moonposition(TTms);//月の位置

var λMoon = Moon[1];//月の視黄緯λ

var Moonalt = new Array();
var Moonhrz = horizontal(Moon[5]/15,Moon[6],TTnowmillisec,λ,φ);//月の地平座標
if(Moonhrz[1] < -0.5){Mooncomment0 = "※月は地平線下。<del style='opacity:0.5'>";
Mooncomment1 = "</del>";}

var αMoonrad = Moon[10];
var δMoonrad = Moon[11];
var rMoonAU = Moon[4]/149597870;//月距離。単位au
var MoonElongrad = Math.acos(Math.sin(δn*Math.PI/180)*Math.sin(δMoonrad) + Math.cos(δn*Math.PI/180)*Math.cos(δMoonrad)*Math.cos(αn*Math.PI/180 - αMoonrad));//月と彗星の離角。ラジアン
var MoonElong = MoonElongrad*180/Math.PI;//月と彗星の離角。度。


//月齢計算
var MoonAge;
var Cretime0;
var Cretime = new Array();//新月時刻
var Moon0 = new Array();
var Earth0 = new Array();
var λMoon0;
var λSun0;
var ΔλMS = new Array();
if(λMoon < λSun){λMoon = λMoon + 360;}
ΔλMS[0] = (λMoon - λSun) % 360;//月と太陽の黄経差
var MoonAge0 = (ΔλMS[0]/12.1818) * 86400*1000;//月齢1次近似・ミリ秒単位
Cretime[0] = TTms - MoonAge0;//1次近似の新月時刻（ミリ秒）
for(var i=0;Math.abs(ΔλMS[i]) > 0.01;i++){
if(i == 100) break;//100回やってダメなら諦める
//近似的な新月時刻をさらに入力
Moon0 = moonposition(Cretime[i]);
λMoon0 = Moon0[1];
Earth0 = earthposition(Cretime[i]);
λSun0 = Earth0[4] + 180;
if(λSun0 > 360){λSun0 = λSun0 -360;}
ΔλMS [i+1]= (λMoon0 - λSun0) % 360;
if(ΔλMS[i+1] > 180){
ΔλMS[i+1] = ΔλMS[i+1] - 360;//近似計算の結果が新月前なら360°を減じてマイナス値に。
}
Cretime[i+1] = Cretime[i] - (ΔλMS[i+1]/12.1818)* 86400*1000 ;//月齢ミリ秒単位
Cretime0 = Cretime[i+1] ;//新月時刻結果を
}
MoonAge = (TTms - Cretime0)/(86400000);
var Mooncomment = Mooncomment0
 + "月齢&#9789;=" + MoonAge.toFixed(2)
 + "　月離角 Elong<sub>&#9789;</sub>= " + MoonElong.toFixed(0) + "°"
 + "<small>（地心）</small>　月高度 alt<sub>&#9789;</sub>=" + Moonhrz[1].toFixed(1)
 + "°<br />"
 + Mooncomment1;


*/
//
//出力。視位置と光度は非表示。

document.getElementById("cometrepo1").innerHTML = TimedataE
 + cometDist
 + cometP2000
 + "太陽離角 Elong<sub>&#x25C9;</sub>=" + sc.toFixed(1) + "°<br />"
 + "位相角 β=" + β.toFixed(1) + "°<br />"
 + cometHorizCom
 + suncomment
 + ΔE;

document.getElementById("cometrepo2").innerHTML = MAGA + COMAE + TAILtlueE;


//大気吸収補正に彗星高度を表示
document.atmosform.starAalt.value = cometHoriz[1].toFixed(1);

//彗星高度が0度以下の時警告。
if(cometAlt <= -0.5722){
var INPUTerror1 = "<p><b>指定された時刻の彗星は地平線下です。彗星本体を観測している場合は、観測時刻や彗星名・軌道データなどを再確認してください。</b>";
}else{
var INPUTerror1 = "";
}
//彗星高度が20度以下の時。ICQフォーマットのエラー欄に警告。
var MAG00 = document.icqform.mag.value;//観測光度m1読み込み
var OBSair = document.icqform.air.value;//大気吸収補正

if(MAG00 != "" && OBSair == "" && cometAlt <= 20 && cometAlt > -0.5722){
var INPUTerror2 = "<p>彗星高度が20度以下ですが、大気吸収補正項目が未入力です。補正を行っていない場合は、「&」を記入してください。</p>";
if(document.icqform.nobs.checked){//非観測の場合はメッセージ無し
var INPUTerror2 = "";
}
}else{
var INPUTerror2 = "";
}
//尾の観測値が長すぎる時（数値がマイナス）
if(TAILtlue < 0){
var INPUTerror3 = "<p>尾の見かけの長さが幾何学的に取り得る最大値を超えています。単位や入力値を確認してください（※尾が宇宙空間上で曲がっている場合もあります）。</p>";
}else{
var INPUTerror3 = "";
}
document.getElementById("inputerror2").innerHTML = INPUTerror1 + INPUTerror2 + INPUTerror3;




document.getElementById("sunAnglenum").value = VSun.toFixed(1);//画像描画テキストフォームに入れる。
document.getElementById("elongnum").value = sc.toFixed(0);//離角。描画で使用
document.getElementById("cometorbR").value = rr.toFixed(3);
document.getElementById("cometorbΔ").value = Δ.toFixed(3);
}

//観測地をフォームに自動的に入れる。
function obsPositionSet(){
document.icqform.elements["obsλ"].value = Number(document.icqform.obsposition.value.slice(0,9));
document.icqform.obsφ.value = Number(document.icqform.obsposition.value.slice(9,17));
document.icqform.obsheight.value = Number(document.icqform.obsposition.value.slice(17,21));
//大気減光計算のテキストに観測地と標高を表示
//document.getElementById("atmos_obsposition").innerHTML = document.icqform.elements["obsposition"].text;
document.getElementById("atmos_height").innerHTML = document.icqform.obsposition.value.slice(17,21);
}
function obsPositionHeightSet(){
document.getElementById("atmos_height").innerHTML = document.icqform.obsheight.value;
}